import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D

from metrics.perturbation_score import perturbation
from utilities.load_save_data import read_csv


def count_edges(adjacency_map):
    """
    :param adjacency_map: adjacency_map of a graph
    :return: number of edges of the whole graph
    """
    number_of_edges = 0
    for i in adjacency_map.keys():
        number_of_edges += len(adjacency_map[i])
    return number_of_edges


def perturbation_scores_plot_0(filename_0, filename_1, n=100):
    """
    plot perturbation scores between graphs in Markov chain and the original graph
    :param filename_0: file path of the original graph
    :param filename_1: file path of generated graphs
    :param n: number of steps
    """
    adjacency_map_0 = read_csv(filename=filename_0)
    number_of_edges = count_edges(adjacency_map=adjacency_map_0)
    perturbation_scores = []
    for i in range(1, n + 1):
        adjacency_map_1 = read_csv(filename=filename_1.format(i))
        perturbation_scores.append(perturbation(adjacency_map_0=adjacency_map_0, adjacency_map_1=adjacency_map_1)/number_of_edges)
    plt.figure(dpi=600)
    x = np.arange(1, n+1)
    y = np.array(perturbation_scores)
    plt.xlabel('Number of steps')
    plt.ylabel('Perturbation scores')
    plt.ylim((0.0, 1.0))
    plt.plot(x, y, label=r'$prt(G_{0}, G_{i})$')
    plt.scatter(x, y, s=15, alpha=0.5)
    plt.legend(loc='lower right')
    plt.grid(True)
    plt.show()


def perturbation_scores_plot(filename_0, filename_1, n=100):
    """
    plot perturbation scores between graphs in the Markov chain and their previous one
    """
    adjacency_map_0 = read_csv(filename=filename_0)
    number_of_edges = count_edges(adjacency_map=adjacency_map_0)
    adjacency_map_1 = adjacency_map_0
    perturbation_scores = []
    for i in range(1, n + 1):
        adjacency_map_2 = read_csv(filename=filename_1.format(i))
        perturbation_scores.append(perturbation(adjacency_map_0=adjacency_map_1, adjacency_map_1=adjacency_map_2)/number_of_edges)
        adjacency_map_1 = adjacency_map_2
    plt.figure(dpi=600)
    x = np.arange(1, n+1)
    y = np.array(perturbation_scores)
    plt.xlabel('Number of steps')
    plt.ylabel('Perturbation scores')
    plt.ylim((0.0, 1.0))
    plt.plot(x, y, label=r'$prt(G_{i-1}, G_{i})$')
    plt.scatter(x, y, s=15, alpha=0.5)
    plt.legend(loc='lower right')
    plt.grid(True)
    plt.show()


def perturbation_scores_plot_3d(filename_0, filename_1, n=100):
    """
    perturbation_scores[i][j]: perturbation score between G_i and G_j
    """
    perturbation_scores = np.zeros((n+1, n+1))
    adjacency_map_0 = read_csv(filename=filename_0)
    number_of_edges = count_edges(adjacency_map=adjacency_map_0)
    for i in range(1, n):
        adjacency_map_1 = read_csv(filename=filename_1.format(i))
        # [0][i] = [i][0]
        perturbation_scores[0][i] = perturbation_scores[i][0] = perturbation(adjacency_map_0=adjacency_map_0, adjacency_map_1=adjacency_map_1)/number_of_edges
        for j in range(i + 1, n + 1):
            adjacency_map_2 = read_csv(filename=filename_1.format(j))
            # [i][j] = [j][i]
            perturbation_scores[i][j] = perturbation_scores[j][i] = perturbation(adjacency_map_0=adjacency_map_1, adjacency_map_1=adjacency_map_2)/number_of_edges
    perturbation_scores[0][n] = perturbation_scores[n][0] = perturbation(adjacency_map_0=adjacency_map_0, adjacency_map_1=adjacency_map_2)/number_of_edges
    fig = plt.figure(dpi=600)
    ax = Axes3D(fig)
    fig.set_tight_layout(False)
    x = np.arange(n + 1)
    y = np.arange(n + 1)
    x, y = np.meshgrid(x, y)
    z = np.array(perturbation_scores)
    plt.xlabel('Number of steps')
    plt.ylabel('Number of steps')
    ax.plot_wireframe(x, y, z, rstride=round(n / 10), cstride=round(n / 10))
    plt.show()


def compare_perturbation_scores_plot_0(filename_0, filename_1, n=100, seed=1):
    """
    plot perturbation scores between the original graph and graphs in Markov chains generated by different seeds
    :param filename_0: file path of the original graph
    :param filename_1: file path of generated graphs
    :param n: number of steps
    :param seed: number of seeds starting from 0
    """
    adjacency_map_0 = read_csv(filename=filename_0)
    number_of_edges = count_edges(adjacency_map=adjacency_map_0)
    plt.figure(dpi=600)
    plt.xlabel('Number of steps')
    plt.ylabel('Perturbation scores')
    perturbation_scores = np.zeros((seed, n))
    for s in range(seed):
        for i in range(n):
            adjacency_map_1 = read_csv(filename=filename_1.format(s, i+1))
            perturbation_scores[s][i] = perturbation(adjacency_map_0=adjacency_map_0, adjacency_map_1=adjacency_map_1)/number_of_edges
        plt.plot(range(1, n + 1), perturbation_scores[s], label=r'$prt(G_{0}, G_{i})$' + ' with seed={})'.format(s))
    plt.plot(range(1, n + 1), perturbation_scores.mean(axis=0), '*', label=r'average $prt(G_{0}, G_{i})$')
    plt.legend(loc='lower right')
    plt.grid(True)
    plt.show()

